"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.analyzeTasks = void 0;
var path_1 = require("path");
var fs_1 = require("fs");
var config_1 = require("./config");
var misc_1 = require("../utils/misc");
var files_1 = require("../utils/files");
var log_1 = require("../utils/log");
var analyzeTasks = function (gulp, $, settings) {
    gulp.task('analyze', function (cb) {
        (function () { return __awaiter(void 0, void 0, void 0, function () {
            var configs, _a, webpackItemsMaps, _i, webpackItemsMaps_1, item, target, sourceMap, res;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        (0, log_1.processStepMessage)('Analyze Webpack Bundle');
                        _a = global.gulpConfigs;
                        if (_a) return [3, 2];
                        return [4, (0, config_1.getConfigs)(settings)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        configs = _a;
                        webpackItemsMaps = configs.appConfig.webpackItemsMap || [{
                                entry: './src/scripts/index.ts',
                                target: 'app.js'
                            }];
                        _i = 0, webpackItemsMaps_1 = webpackItemsMaps;
                        _b.label = 3;
                    case 3:
                        if (!(_i < webpackItemsMaps_1.length)) return [3, 8];
                        item = webpackItemsMaps_1[_i];
                        target = "".concat(configs.appConfig.distFolder, "/scripts/").concat(item.target);
                        sourceMap = (0, files_1.extractSourcemapPath)(target);
                        if (!sourceMap) return [3, 6];
                        sourceMap = "".concat(configs.appConfig.distFolder, "/scripts/").concat(sourceMap.split('?')[0]);
                        if (!(0, fs_1.existsSync)(sourceMap)) return [3, 5];
                        return [4, (0, misc_1.execPromise)("".concat((0, path_1.join)(process.cwd(), 'node_modules/.bin', 'source-map-explorer'), " ").concat(target, " ").concat(sourceMap))];
                    case 4:
                        res = _b.sent();
                        if (res.stdout)
                            console.log("".concat(res.stdout));
                        if (res.stderr)
                            console.log("".concat(res.stderr));
                        _b.label = 5;
                    case 5: return [3, 7];
                    case 6:
                        console.log("No source map found in ".concat(target));
                        _b.label = 7;
                    case 7:
                        _i++;
                        return [3, 3];
                    case 8: return [2];
                }
            });
        }); })().then(function () { return cb(); }).catch(cb);
    });
};
exports.analyzeTasks = analyzeTasks;
//# sourceMappingURL=analyze.js.map