import { Gulp } from 'gulp';
import Build from '../utils/build';
import { ISPBuildSettings, IGulpConfigs } from '../interfaces';
export declare const buildTasks: (gulp: Gulp, $: any, settings: ISPBuildSettings) => void;
export declare const mapProjectData: (configs: IGulpConfigs) => any;
export declare const getBuildInstance: (settings: IGulpConfigs) => Build;
export declare class BuildTasks {
    private settings;
    constructor(settings: ISPBuildSettings);
    buildJsLibsTask: () => Promise<void>;
    buildWebpackTask: (parallelism?: number) => Promise<void>;
    buildCssLibsTask: () => Promise<void>;
    buildCustomCssTask: () => Promise<void>;
    buildCopyAssetsTask: () => Promise<void>;
    buildMasterpagesTask: () => Promise<void>;
    buildLayoutsTask: () => Promise<void>;
    buildWebpartsTask: () => Promise<void>;
    private mapHbsTemplates;
}
