"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BuildTasks = exports.getBuildInstance = exports.mapProjectData = exports.buildTasks = void 0;
var path = __importStar(require("path"));
var fs = __importStar(require("fs"));
var mkdirp = __importStar(require("mkdirp"));
var webpack_1 = __importDefault(require("webpack"));
var listr_1 = __importDefault(require("listr"));
var minimist_1 = __importDefault(require("minimist"));
var config_1 = require("./config");
var build_1 = __importDefault(require("../utils/build"));
var misc_1 = require("../utils/misc");
var env_1 = require("../utils/env");
var log_1 = require("../utils/log");
var buildTasks = function (gulp, $, settings) {
    var bt = new BuildTasks(settings);
    gulp.task('build', function (cb) {
        var mode = (0, env_1.detectProdMode)();
        var args = process.argv.slice(3);
        (function () { return __awaiter(void 0, void 0, void 0, function () {
            var tasksInfo, tasks;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        (0, log_1.processStepMessage)("Build (mode: ".concat(mode, ")"));
                        if (!!fs.existsSync(path.resolve(settings.privateConf || './config/private.json'))) return [3, 2];
                        return [4, (0, config_1.getConfigs)(settings, false)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        tasksInfo = [
                            { key: '--copy-assets', title: 'Copy Assets', task: bt.buildCopyAssetsTask },
                            { key: '--webparts', title: 'Build CEWPs', task: bt.buildWebpartsTask },
                            { key: '--masterpage', title: 'Build Masterpages', task: bt.buildMasterpagesTask },
                            { key: '--layouts', title: 'Build Layouts', task: bt.buildLayoutsTask },
                            { key: '--css-custom', title: 'Build Custom CSS', task: bt.buildCustomCssTask },
                            { key: '--css-libs', title: 'Build CSS Libraries', task: bt.buildCssLibsTask },
                            { key: '--js-libs', title: 'Build JavaScript DLLs', task: bt.buildJsLibsTask },
                            { key: '--webpack', title: 'Starting Webpack build', task: function () { return Promise.resolve(); } }
                        ];
                        tasks = tasksInfo.filter(function (task) { return args.indexOf(task.key) !== -1; });
                        tasks = tasks.length > 0 ? tasks : tasksInfo;
                        return [4, new listr_1.default(tasks).run()];
                    case 3:
                        _a.sent();
                        if (!(args.indexOf('--webpack') !== -1 || tasksInfo.length === tasks.length)) return [3, 5];
                        if (!(args.indexOf('--no-webpack') === -1)) return [3, 5];
                        return [4, bt.buildWebpackTask()];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2];
                }
            });
        }); })()
            .then(function () { return cb(); })
            .catch(cb);
    });
};
exports.buildTasks = buildTasks;
var mapProjectData = function (configs) {
    var serverPath = configs.privateConf.siteUrl.split('/').splice(0, 3).join('/');
    var publishPath = "".concat(configs.privateConf.siteUrl, "/").concat(configs.appConfig.spFolder)
        .replace(serverPath, '')
        .replace(/\/\//g, '/');
    var packageData = require(path.join(process.cwd(), 'package.json'));
    var data = __assign(__assign({ serverPath: serverPath, publishPath: publishPath, absolutePublishPath: "".concat(serverPath).concat(publishPath), masterpageName: configs.appConfig.masterpageCodeName, siteUrl: configs.privateConf.siteUrl, spRootFolder: configs.appConfig.spFolder, assetsVersion: packageData.version + '_' + (new Date()).getTime() }, (configs.appConfig.masterpage || {})), { customData: __assign({}, (configs.appConfig.customData || {})) });
    return data;
};
exports.mapProjectData = mapProjectData;
var getBuildInstance = function (settings) {
    global.build = global.build || new build_1.default({ dist: settings.appConfig.distFolder, fileEncoding: 'utf-8' });
    return global.build;
};
exports.getBuildInstance = getBuildInstance;
var BuildTasks = (function () {
    function BuildTasks(settings) {
        var _this = this;
        this.settings = settings;
        this.buildJsLibsTask = function () { return __awaiter(_this, void 0, void 0, function () {
            var configs, _a, build, filesArr, distPath, content, res;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = global.gulpConfigs;
                        if (_a) return [3, 2];
                        return [4, (0, config_1.getConfigs)(this.settings)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        configs = _a;
                        build = (0, exports.getBuildInstance)(configs);
                        filesArr = (typeof configs.appConfig.bundleJSLibsFiles !== 'undefined'
                            ? configs.appConfig.bundleJSLibsFiles : []).map(env_1.compileEnvHashedString);
                        distPath = configs.appConfig.distFolder + '/scripts/vendor.js';
                        return [4, build.concatFilesContent({ filesArr: filesArr })];
                    case 3:
                        content = _b.sent();
                        if (content) {
                            res = build.minifyJsContent({ content: content, distPath: distPath });
                            if (res.error) {
                                throw new Error(res.error.message);
                            }
                        }
                        return [2];
                }
            });
        }); };
        this.buildWebpackTask = function (parallelism) {
            if (parallelism === void 0) { parallelism = 1; }
            return __awaiter(_this, void 0, void 0, function () {
                var args, webpackConfigPath, webpackConfig, webpackConfigs, queueIndex, confQueue, _i, webpackConfigs_1, conf, bundlingItems;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            args = (0, minimist_1.default)(process.argv.slice(3));
                            webpackConfigPath = path.join(process.cwd(), 'webpack.config.js');
                            if (!fs.existsSync(webpackConfigPath)) {
                                webpackConfigPath = path.join(__dirname, '../webpack/config.js');
                            }
                            webpackConfig = require(webpackConfigPath);
                            webpackConfigs = Array.isArray(webpackConfig) ? webpackConfig : [webpackConfig];
                            console.log('');
                            queueIndex = 0;
                            confQueue = [];
                            _i = 0, webpackConfigs_1 = webpackConfigs;
                            _a.label = 1;
                        case 1:
                            if (!(_i < webpackConfigs_1.length)) return [3, 4];
                            conf = webpackConfigs_1[_i];
                            confQueue = confQueue.concat(conf);
                            queueIndex += 1;
                            if (!(confQueue.length === parallelism || queueIndex === webpackConfigs.length)) return [3, 3];
                            bundlingItems = confQueue.map(function (c) {
                                var entries = Array.isArray(c.entry) ? c.entry : [c.entry];
                                if (c.name) {
                                    return "".concat(c.name);
                                }
                                return "".concat(entries.join(', '));
                            });
                            if (bundlingItems.length === 1) {
                                console.log("Bundling: ".concat(bundlingItems[0]));
                            }
                            else {
                                console.log("Bundling: \n".concat(bundlingItems.map(function (b) { return "  - ".concat(b); }).join('\n')));
                            }
                            return [4, new Promise(function (resolve, reject) {
                                    (0, webpack_1.default)(confQueue, function (err, stats) {
                                        if (err) {
                                            reject(err.message);
                                        }
                                        if (args['webpack-stats']) {
                                            console.log(stats.toString({ colors: true }));
                                        }
                                        else {
                                            console.error(stats.toString('errors-only'));
                                        }
                                        resolve();
                                    });
                                })];
                        case 2:
                            _a.sent();
                            confQueue = [];
                            _a.label = 3;
                        case 3:
                            _i++;
                            return [3, 1];
                        case 4: return [2];
                    }
                });
            });
        };
        this.buildCssLibsTask = function () { return __awaiter(_this, void 0, void 0, function () {
            var configs, _a, build, filesArr, distPath, content;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = global.gulpConfigs;
                        if (_a) return [3, 2];
                        return [4, (0, config_1.getConfigs)(this.settings)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        configs = _a;
                        build = (0, exports.getBuildInstance)(configs);
                        filesArr = (typeof configs.appConfig.bundleCSSLibsFiles !== 'undefined'
                            ? configs.appConfig.bundleCSSLibsFiles : []).map(env_1.compileEnvHashedString);
                        distPath = configs.appConfig.distFolder + '/styles/vendor.css';
                        return [4, build.concatFilesContent({ filesArr: filesArr })];
                    case 3:
                        content = _b.sent();
                        if (content) {
                            build.minifyCssContent({ content: content, distPath: distPath });
                        }
                        return [2];
                }
            });
        }); };
        this.buildCustomCssTask = function () { return __awaiter(_this, void 0, void 0, function () {
            var configs, _a, build, assetsArr, defaultMap, _i, assetsArr_1, assets, srcPathString, srcPath, distPath, sourceMapPath, _b, name, ext, sourceMapFile, result, re;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = global.gulpConfigs;
                        if (_a) return [3, 2];
                        return [4, (0, config_1.getConfigs)(this.settings)];
                    case 1:
                        _a = (_c.sent());
                        _c.label = 2;
                    case 2:
                        configs = _a;
                        build = (0, exports.getBuildInstance)(configs);
                        assetsArr = [];
                        defaultMap = {
                            src: 'styles/index.scss',
                            dist: 'styles/app.css'
                        };
                        if (!configs.appConfig.customStyles) {
                            assetsArr.push(__assign({}, defaultMap));
                        }
                        else if (!Array.isArray(configs.appConfig.customStyles)) {
                            assetsArr.push({
                                src: configs.appConfig.customStyles.src || defaultMap.src,
                                dist: configs.appConfig.customStyles.dist || defaultMap.dist
                            });
                        }
                        else {
                            assetsArr = configs.appConfig.customStyles;
                        }
                        _i = 0, assetsArr_1 = assetsArr;
                        _c.label = 3;
                    case 3:
                        if (!(_i < assetsArr_1.length)) return [3, 6];
                        assets = assetsArr_1[_i];
                        srcPathString = (0, env_1.compileEnvHashedString)(assets.src);
                        srcPath = path.join(process.cwd(), 'src', srcPathString);
                        if (!fs.existsSync(srcPath)) return [3, 5];
                        distPath = path.join(process.cwd(), configs.appConfig.distFolder, (configs.appConfig.modulePath || ''), assets.dist);
                        sourceMapPath = distPath + '.map';
                        _b = path.parse(sourceMapPath), name = _b.name, ext = _b.ext;
                        sourceMapFile = "".concat(name).concat(ext);
                        return [4, build.buildCustomCssFromScss({ file: srcPath, sourceMap: sourceMapFile, sourceMapContents: true })];
                    case 4:
                        result = _c.sent();
                        if (result) {
                            mkdirp.sync(path.dirname(distPath));
                            re = new RegExp("(sourceMappingURL=)(.*?)(".concat(sourceMapFile, ")"), 'g');
                            fs.writeFileSync(distPath, result.css.toString().replace(re, '$1$3'), { encoding: 'utf-8' });
                            if (result.map) {
                                fs.writeFileSync(sourceMapPath, result.map.toString(), { encoding: 'utf-8' });
                            }
                        }
                        _c.label = 5;
                    case 5:
                        _i++;
                        return [3, 3];
                    case 6: return [2];
                }
            });
        }); };
        this.buildCopyAssetsTask = function () { return __awaiter(_this, void 0, void 0, function () {
            var configs, _a, build, assetsToCopy, _i, assetsToCopy_1, assets, srcArrayOrPath;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = global.gulpConfigs;
                        if (_a) return [3, 2];
                        return [4, (0, config_1.getConfigs)(this.settings)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        configs = _a;
                        build = (0, exports.getBuildInstance)(configs);
                        assetsToCopy = configs.appConfig.copyAssetsMap || [];
                        for (_i = 0, assetsToCopy_1 = assetsToCopy; _i < assetsToCopy_1.length; _i++) {
                            assets = assetsToCopy_1[_i];
                            srcArrayOrPath = (typeof assets.src === 'string' ? [assets.src] : assets.src).map(env_1.compileEnvHashedString);
                            build.copyAssets({ srcArrayOrPath: srcArrayOrPath, dist: (0, env_1.compileEnvHashedString)(assets.dist) });
                        }
                        return [2];
                }
            });
        }); };
        this.buildMasterpagesTask = function () { return __awaiter(_this, void 0, void 0, function () {
            var configs, _a, build, data, source, target;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = global.gulpConfigs;
                        if (_a) return [3, 2];
                        return [4, (0, config_1.getConfigs)(this.settings)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        configs = _a;
                        build = (0, exports.getBuildInstance)(configs);
                        data = (0, exports.mapProjectData)(configs);
                        source = "./src/masterpage/".concat(configs.appConfig.masterpageCodeName, ".").concat(configs.appConfig.platformVersion || '___', ".hbs").replace('.___.', '.');
                        target = "".concat(configs.appConfig.distFolder, "/masterpage/").concat(configs.appConfig.masterpageCodeName, ".master");
                        if (!fs.existsSync(source)) return [3, 4];
                        return [4, build.compileHbsTemplate({ source: source, target: target, data: data })];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4: return [2];
                }
            });
        }); };
        this.buildLayoutsTask = function () { return __awaiter(_this, void 0, void 0, function () {
            var configs, _a, build, data, source, target, files;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = global.gulpConfigs;
                        if (_a) return [3, 2];
                        return [4, (0, config_1.getConfigs)(this.settings)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        configs = _a;
                        build = (0, exports.getBuildInstance)(configs);
                        data = (0, exports.mapProjectData)(configs);
                        source = './src/masterpage/layouts';
                        target = configs.appConfig.distFolder + '/masterpage/layouts';
                        if (!fs.existsSync(source)) {
                            return [2];
                        }
                        files = this.mapHbsTemplates(fs.readdirSync(source), source, target, 'aspx');
                        if (!(files.length > 0)) return [3, 4];
                        return [4, build.compileHbsTemplates({ files: files, data: data })];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4: return [2];
                }
            });
        }); };
        this.buildWebpartsTask = function () { return __awaiter(_this, void 0, void 0, function () {
            var configs, _a, build, data, source, target, webpartsFiles, files;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = global.gulpConfigs;
                        if (_a) return [3, 2];
                        return [4, (0, config_1.getConfigs)(this.settings)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        configs = _a;
                        build = (0, exports.getBuildInstance)(configs);
                        data = (0, exports.mapProjectData)(configs);
                        source = './src/webparts';
                        target = "".concat(configs.appConfig.distFolder, "/").concat((configs.appConfig.modulePath || ''), "/webparts").replace(/\/\//g, '/');
                        if (!fs.existsSync(source)) {
                            return [2];
                        }
                        webpartsFiles = (0, misc_1.walkFolders)(source).map(function (f) { return f.replace("".concat(source, "/"), ''); });
                        files = this.mapHbsTemplates(webpartsFiles, source, target, 'html');
                        if (!(files.length > 0)) return [3, 4];
                        return [4, build.compileHbsTemplates({ files: files, data: data })];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4: return [2];
                }
            });
        }); };
    }
    BuildTasks.prototype.mapHbsTemplates = function (files, source, target, ext) {
        return files
            .map(function (file) { return [path.join(source, file), file]; })
            .filter(function (_a) {
            var filePath = _a[0];
            return !fs.lstatSync(filePath).isDirectory();
        })
            .filter(function (_a) {
            var filePath = _a[0];
            return path.parse(filePath).ext.toLowerCase() === '.hbs';
        })
            .map(function (_a) {
            var filePath = _a[0], file = _a[1];
            return {
                source: filePath,
                target: path.join(target, "".concat(file.replace('.hbs', ''), ".").concat(ext))
            };
        });
    };
    return BuildTasks;
}());
exports.BuildTasks = BuildTasks;
//# sourceMappingURL=build.js.map