"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.watchAssets = exports.watchTasks = void 0;
var path = __importStar(require("path"));
var fs = __importStar(require("fs"));
var webpack_1 = __importDefault(require("webpack"));
var sppurge_1 = __importDefault(require("sppurge"));
var sp_live_reload_1 = require("sp-live-reload");
var log_1 = require("../utils/log");
var config_1 = require("./config");
var misc_1 = require("../utils/misc");
var build_1 = require("./build");
var env_1 = require("../utils/env");
var watchTasks = function (gulp, $, settings) {
    var run = new misc_1.Debounce(50).run;
    var saveQueue = {};
    var spsave = function (filePath, throughCallback) { return __awaiter(void 0, void 0, void 0, function () {
        var configs, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = global.gulpConfigs;
                    if (_a) return [3, 2];
                    return [4, (0, config_1.getConfigs)(settings)];
                case 1:
                    _a = (_b.sent());
                    _b.label = 2;
                case 2:
                    configs = _a;
                    saveQueue[filePath] = (saveQueue[filePath] || 0) + 1;
                    console.log("[".concat((0, misc_1.formatTime)(new Date()), "]"), 'Watch:', path.relative('./', filePath), fs.statSync(filePath).size, saveQueue[filePath] > 1 ? '(delayed)' : '');
                    if (saveQueue[filePath] === 1) {
                        gulp
                            .src(filePath, { base: configs.watch.base })
                            .pipe($.spsave(configs.spSaveCoreOptions, configs.privateConf.creds))
                            .pipe($.through.obj(function (chunk, _enc, callback) {
                            if (typeof throughCallback !== 'undefined') {
                                var chunkPath = chunk.path;
                                throughCallback(chunkPath);
                            }
                            saveQueue[filePath] -= 1;
                            if (saveQueue[filePath] > 0) {
                                delete saveQueue[filePath];
                                spsave(filePath).then(function () { return callback(null, chunk); }).catch(console.warn);
                            }
                            else {
                                callback(null, chunk);
                            }
                        }));
                    }
                    return [2];
            }
        });
    }); };
    var purge = function (filePath) { return __awaiter(void 0, void 0, void 0, function () {
        var configs, _a, sppurgeOptions;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = global.gulpConfigs;
                    if (_a) return [3, 2];
                    return [4, (0, config_1.getConfigs)(settings)];
                case 1:
                    _a = (_b.sent());
                    _b.label = 2;
                case 2:
                    configs = _a;
                    sppurgeOptions = {
                        folder: configs.appConfig.spFolder,
                        localFilePath: filePath,
                        localBasePath: configs.appConfig.distFolder
                    };
                    (0, sppurge_1.default)(configs.privateConf, sppurgeOptions)
                        .catch(function (err) {
                        if ((err.error || { error: { code: '' } }).error.code.split(',')[0] === '-2146232832') {
                            console.log('File has not been removed as it was not there in SharePoint.');
                        }
                        else {
                            console.log('Error:', err.message);
                        }
                    });
                    return [2];
            }
        });
    }); };
    var buildTasks = new build_1.BuildTasks(settings);
    gulp.task('watch', function () {
        var args = process.argv.slice(3);
        var devServer = args.indexOf('--devServer') !== -1;
        var skipSync = devServer || args.indexOf('--skipSync') !== -1;
        (0, env_1.detectProdMode)();
        (function () { return __awaiter(void 0, void 0, void 0, function () {
            var configs, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = global.gulpConfigs;
                        if (_a) return [3, 2];
                        return [4, (0, config_1.getConfigs)(settings)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        configs = _a;
                        if (!skipSync) {
                            (0, log_1.processStepMessage)('Watch has been started');
                            $.watch(configs.watch.assets, function (event) { return __awaiter(void 0, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            if (!(event.event !== 'unlink')) return [3, 2];
                                            return [4, new Promise(function (resolve, reject) {
                                                    run(event.path, function () {
                                                        spsave(event.path)
                                                            .then(function () { return resolve(); })
                                                            .catch(reject);
                                                    });
                                                })];
                                        case 1:
                                            _a.sent();
                                            return [3, 4];
                                        case 2:
                                            if (!configs.appConfig.deleteFiles) return [3, 4];
                                            return [4, purge(event.path)];
                                        case 3:
                                            _a.sent();
                                            _a.label = 4;
                                        case 4: return [2];
                                    }
                                });
                            }); });
                        }
                        (0, exports.watchAssets)(buildTasks, configs, $, devServer);
                        return [2];
                }
            });
        }); })()
            .catch(console.warn);
    });
    gulp.task('live', function () {
        (0, log_1.processStepMessage)('Watch with reload is initiated');
        (0, env_1.detectProdMode)();
        (function () { return __awaiter(void 0, void 0, void 0, function () {
            var configs, _a, liveReload;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = global.gulpConfigs;
                        if (_a) return [3, 2];
                        return [4, (0, config_1.getConfigs)(settings)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        configs = _a;
                        liveReload = new sp_live_reload_1.LiveReload(configs.liveReload);
                        liveReload.runServer();
                        $.watch(configs.watch.assets, function (event) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!(event.event !== 'unlink')) return [3, 2];
                                        return [4, new Promise(function (resolve, reject) {
                                                run(event.path, function () {
                                                    spsave(event.path, function (chunkPath) {
                                                        var body = '';
                                                        if (chunkPath.toLowerCase().split('.').pop() === 'css') {
                                                            body = fs.readFileSync(chunkPath).toString();
                                                        }
                                                        liveReload.emitUpdatedPath(chunkPath, false, body);
                                                    })
                                                        .then(function () { return resolve(); })
                                                        .catch(reject);
                                                });
                                            })];
                                    case 1:
                                        _a.sent();
                                        return [3, 4];
                                    case 2:
                                        if (!configs.appConfig.deleteFiles) return [3, 4];
                                        return [4, purge(event.path)];
                                    case 3:
                                        _a.sent();
                                        _a.label = 4;
                                    case 4: return [2];
                                }
                            });
                        }); });
                        (0, exports.watchAssets)(buildTasks, configs, $, false);
                        return [2];
                }
            });
        }); })()
            .catch(console.warn);
    });
};
exports.watchTasks = watchTasks;
var watchAssets = function (buildTasks, configs, $, devServer) {
    if (devServer === void 0) { devServer = false; }
    var webpackWatch = function () {
        var webpackConfigPath = path.join(process.cwd(), 'webpack.config.js');
        if (!fs.existsSync(webpackConfigPath)) {
            webpackConfigPath = path.join(__dirname, '../webpack/config.js');
        }
        var webpackConfig = require(webpackConfigPath);
        if (!Array.isArray(webpackConfig)) {
            webpackConfig = [webpackConfig];
        }
        webpackConfig = webpackConfig.map(function (w) {
            return __assign(__assign({}, w), { watch: true, watchOptions: {
                    aggregateTimeout: 300,
                    poll: 1000,
                    ignored: /node_modules/
                } });
        });
        (0, webpack_1.default)(webpackConfig, function (err, stats) {
            console.log(err || stats.toString({ colors: true }));
        });
    };
    $.watch("./src/masterpage/".concat(configs.appConfig.masterpageCodeName, ".").concat(configs.appConfig.platformVersion || '___', ".hbs").replace('.___.', '.'), function (event) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(event.event !== 'unlink')) return [3, 2];
                    return [4, buildTasks.buildMasterpagesTask()];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [2];
            }
        });
    }); });
    $.watch('./src/masterpage/layouts/*.hbs', function (event) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(event.event !== 'unlink')) return [3, 2];
                    return [4, buildTasks.buildLayoutsTask()];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [2];
            }
        });
    }); });
    $.watch('./src/styles/**/*.scss', function (event) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(event.event !== 'unlink')) return [3, 2];
                    return [4, buildTasks.buildCustomCssTask()];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [2];
            }
        });
    }); });
    if (!devServer) {
        $.watch(__spreadArray(__spreadArray(__spreadArray([], ['js', 'jsx', 'ts', 'tsx'].map(function (ext) { return "./src/scripts/**/*.".concat(ext); }), true), (typeof configs.appConfig.webpackItemsMap !== 'undefined'
            ? configs.appConfig.webpackItemsMap.map(function (c) { return c.entry; })
            : []), true), [
            '!./src/scripts/**/*.d.ts'
        ], false)).once('data', function () { return webpackWatch(); });
    }
    $.watch('./src/webparts/**/*.hbs', function (vinyl) {
        if (vinyl.event !== 'unlink') {
            var build = (0, build_1.getBuildInstance)(configs);
            var data = (0, build_1.mapProjectData)(configs);
            var targetFolder = configs.appConfig.distFolder + '/webparts';
            var srcPath = path.relative('./src', vinyl.path);
            var relPath = path.relative(path.join('./src', 'webparts'), vinyl.path);
            var fileParse = path.parse(relPath);
            var trgPath_1 = path.join(targetFolder, path.dirname(relPath), fileParse.name + '.html');
            build.compileHbsTemplate({
                source: srcPath,
                target: trgPath_1,
                data: data
            })
                .then(function () { return console.log('Webpart is compiled', trgPath_1); })
                .catch(console.log);
        }
    });
};
exports.watchAssets = watchAssets;
//# sourceMappingURL=watch.js.map