import * as UglifyJS from 'uglify-js';
import CleanCSS from 'clean-css';
import * as sass from 'sass';
import { IBuildInitSettings, ICompileHbsTemplates, ICompileHbsTemplate, ICopyAssets, IMinifyContent, IConcatFilesContent, IBuildCustomCssFromScss } from '../interfaces';
export default class Build {
    private settings;
    private copy;
    private EOL;
    constructor(settings?: IBuildInitSettings);
    buildBootstrap3(): Promise<string>;
    buildCustomCssFromScss(params?: IBuildCustomCssFromScss): Promise<sass.LegacyResult | undefined>;
    concatFilesContent(params: IConcatFilesContent): Promise<string>;
    minifyJsContent(params: IMinifyContent): UglifyJS.MinifyOutput;
    minifyCssContent(params: IMinifyContent): CleanCSS.Output;
    copyAssets(params: ICopyAssets): void;
    compileHbsTemplate(params: ICompileHbsTemplate): Promise<{
        targetBody: string;
        targetPath: string;
    }>;
    compileHbsTemplates(params: ICompileHbsTemplates): Promise<{
        targetBody: string;
        targetPath: string;
    }[]>;
}
