"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var Handlebars = __importStar(require("handlebars"));
var path = __importStar(require("path"));
var mkdirp = __importStar(require("mkdirp"));
var UglifyJS = __importStar(require("uglify-js"));
var clean_css_1 = __importDefault(require("clean-css"));
var sass = __importStar(require("sass"));
var copy_1 = __importDefault(require("./copy"));
var Build = (function () {
    function Build(settings) {
        if (settings === void 0) { settings = {}; }
        this.EOL = '\n';
        this.settings = __assign(__assign({}, settings), { src: settings.src || './src', dist: settings.dist || './dist', fileEncoding: settings.fileEncoding || 'utf-8' });
        this.copy = new copy_1.default(this.settings);
    }
    Build.prototype.buildBootstrap3 = function () {
        return __awaiter(this, void 0, void 0, function () {
            var compiledCss, bootstrapRoot, bootstrapFiles, bootstrapPaths, content_1, less_1, compileLess;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        compiledCss = '';
                        bootstrapRoot = path.join(process.cwd(), '/node_modules/bootstrap/less');
                        if (!fs.existsSync(bootstrapRoot)) return [3, 4];
                        bootstrapFiles = [
                            'variables',
                            'mixins',
                            'print',
                            'glyphicons',
                            'code',
                            'grid',
                            'tables',
                            'forms',
                            'buttons',
                            'component-animations',
                            'dropdowns',
                            'button-groups',
                            'input-groups',
                            'navs',
                            'navbar',
                            'breadcrumbs',
                            'pagination',
                            'pager',
                            'badges',
                            'jumbotron',
                            'thumbnails',
                            'alerts',
                            'progress-bars',
                            'media',
                            'list-group',
                            'panels',
                            'responsive-embed',
                            'wells',
                            'close',
                            'modals',
                            'tooltip',
                            'popovers',
                            'carousel',
                            'utilities',
                            'responsive-utilities',
                            'theme'
                        ];
                        bootstrapPaths = bootstrapFiles.map(function (fileName) {
                            return path.join(bootstrapRoot, '/', fileName + '.less');
                        });
                        return [4, this.concatFilesContent({ filesArr: bootstrapPaths })];
                    case 1:
                        content_1 = _a.sent();
                        content_1 += "\n        .row * {\n          box-sizing: border-box;\n        }\n      ";
                        less_1 = null;
                        try {
                            less_1 = require('less');
                        }
                        catch (ex) {
                            console.log('`npm i -D less` is required to build Bootstrap 3');
                        }
                        if (!less_1) return [3, 3];
                        compileLess = function () {
                            return new Promise(function (resolve, reject) {
                                less_1.render(content_1, { filename: path.resolve(path.join(bootstrapRoot, '/_.less')) }, function (err, output) {
                                    if (err) {
                                        reject('Less compilation error:' + err.message);
                                    }
                                    var styles = output.css;
                                    resolve(styles);
                                });
                            });
                        };
                        return [4, compileLess()];
                    case 2:
                        compiledCss = _a.sent();
                        _a.label = 3;
                    case 3: return [3, 5];
                    case 4:
                        console.log('No Bootstrap 3 installed found');
                        _a.label = 5;
                    case 5: return [2, compiledCss];
                }
            });
        });
    };
    Build.prototype.buildCustomCssFromScss = function (params) {
        var _this = this;
        if (params === void 0) { params = {}; }
        return new Promise(function (resolve, reject) {
            var file = params.file, outFile = params.outFile, sourceMap = params.sourceMap, sourceMapContents = params.sourceMapContents;
            var data = params.data || file ? fs.readFileSync(file, _this.settings.fileEncoding).toString() : null;
            var outputStyle = params.outputStyle || 'compressed';
            setTimeout(function () {
                sass.render({ file: file, data: data, outputStyle: outputStyle, outFile: outFile, sourceMap: sourceMap, sourceMapContents: sourceMapContents }, function (err, result) {
                    if (err) {
                        return reject(err);
                    }
                    resolve(result);
                });
            }, 50);
        });
    };
    Build.prototype.concatFilesContent = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var filesArr, distPath, concatedContent, _i, _a, filePath, content, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        filesArr = params.filesArr, distPath = params.distPath;
                        concatedContent = [];
                        _i = 0, _a = (filesArr || []);
                        _c.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3, 6];
                        filePath = _a[_i];
                        if (!(filePath === 'bootstrap3')) return [3, 3];
                        return [4, this.buildBootstrap3()];
                    case 2:
                        _b = _c.sent();
                        return [3, 4];
                    case 3:
                        _b = fs.readFileSync(filePath, { encoding: this.settings.fileEncoding }).toString();
                        _c.label = 4;
                    case 4:
                        content = _b;
                        concatedContent.push(content);
                        _c.label = 5;
                    case 5:
                        _i++;
                        return [3, 1];
                    case 6:
                        if (distPath) {
                            mkdirp.sync(path.dirname(distPath));
                            fs.writeFileSync(distPath, concatedContent.join(this.EOL), this.settings.fileEncoding);
                        }
                        return [2, concatedContent.join(this.EOL)];
                }
            });
        });
    };
    Build.prototype.minifyJsContent = function (params) {
        var distPath = params.distPath;
        var content = typeof params.content !== 'undefined'
            ? params.content
            : fs.readFileSync(params.srcPath, { encoding: this.settings.fileEncoding }).toString();
        var options = {
            compress: true,
            sourceMap: true,
            output: {
                comments: false
            }
        };
        var minifiedContent = UglifyJS.minify(content, options);
        if (distPath && typeof minifiedContent.error === 'undefined') {
            mkdirp.sync(path.dirname(distPath));
            fs.writeFileSync(distPath, minifiedContent.code, { encoding: this.settings.fileEncoding });
        }
        return minifiedContent;
    };
    Build.prototype.minifyCssContent = function (params) {
        var distPath = params.distPath;
        var minifiedContent = new clean_css_1.default({}).minify('');
        var content = typeof params.content !== 'undefined'
            ? params.content
            : fs.readFileSync(params.srcPath, { encoding: this.settings.fileEncoding }).toString();
        minifiedContent = new clean_css_1.default({}).minify(content);
        if (distPath) {
            mkdirp.sync(path.dirname(distPath));
            fs.writeFileSync(distPath, minifiedContent.styles, { encoding: this.settings.fileEncoding });
        }
        return minifiedContent;
    };
    Build.prototype.copyAssets = function (params) {
        var _this = this;
        var srcArrayOrPath = params.srcArrayOrPath, dist = params.dist;
        mkdirp.sync(dist);
        if (Array.isArray(srcArrayOrPath)) {
            srcArrayOrPath.forEach(function (src) { return _this.copy.copyFileOrFolderSync(src, dist); });
        }
        else {
            this.copy.copyFileOrFolderSync(srcArrayOrPath, dist);
        }
    };
    Build.prototype.compileHbsTemplate = function (params) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var source = params.source, target = params.target, data = params.data;
            var src = path.normalize(_this.settings.src || './src');
            var dist = path.normalize(_this.settings.dist || './dist');
            source = path.normalize(source);
            target = path.normalize(target);
            if (source.indexOf(src) !== 0) {
                source = path.join(src, source);
            }
            if (target.indexOf(dist) !== 0) {
                target = path.join(dist, target);
            }
            var fileParse = path.parse(target);
            data = __assign(__assign({}, data), { fileName: "".concat(fileParse.name).concat(fileParse.ext) });
            fs.readFile(source, _this.settings.fileEncoding, function (err, sourceBody) {
                if (err) {
                    reject(err);
                }
                var template = Handlebars.compile(sourceBody.toString());
                var targetBody = template(data);
                mkdirp.sync(path.dirname(target));
                fs.writeFile(target, targetBody, {
                    encoding: _this.settings.fileEncoding
                }, function (err) {
                    if (err) {
                        reject(err);
                    }
                    resolve({ targetBody: targetBody, targetPath: target });
                });
            });
        });
    };
    Build.prototype.compileHbsTemplates = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var files, data, results, _i, files_1, file, source, target, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        files = params.files, data = params.data;
                        results = [];
                        _i = 0, files_1 = files;
                        _a.label = 1;
                    case 1:
                        if (!(_i < files_1.length)) return [3, 4];
                        file = files_1[_i];
                        source = file.source, target = file.target;
                        return [4, this.compileHbsTemplate({ source: source, target: target, data: data })];
                    case 2:
                        result = _a.sent();
                        results.push(result);
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3, 1];
                    case 4: return [2, results];
                }
            });
        });
    };
    return Build;
}());
exports.default = Build;
//# sourceMappingURL=build.js.map