"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var path = __importStar(require("path"));
var Copy = (function () {
    function Copy(settings) {
        if (settings === void 0) { settings = {}; }
        this.settings = __assign(__assign({}, settings), { src: settings.src || './src', dist: settings.dist || './dist', fileEncoding: settings.fileEncoding || 'utf-8' });
    }
    Copy.prototype.copyFileOrFolderSync = function (source, target) {
        var skipFolder = source.endsWith('/*');
        if (skipFolder) {
            source = source.replace('/*', '');
        }
        if (source.split('|').length > 1) {
            var parts = source.split('|');
            source = parts[0];
            target = path.join(target, parts[1]);
        }
        if (fs.existsSync(source)) {
            if (fs.lstatSync(source).isDirectory()) {
                this.copyFolderRecursiveSync(source, target, skipFolder);
            }
            else {
                this.copyFileSync(source, target);
            }
        }
    };
    Copy.prototype.copyFileSync = function (source, target) {
        var targetFile = target;
        if (fs.existsSync(target)) {
            if (fs.lstatSync(target).isDirectory()) {
                targetFile = path.join(target, path.basename(source));
            }
        }
        fs.writeFileSync(targetFile, fs.readFileSync(source), {
            encoding: this.settings.fileEncoding
        });
    };
    Copy.prototype.copyFolderRecursiveSync = function (source, target, skipFolder) {
        var _this = this;
        if (skipFolder === void 0) { skipFolder = false; }
        var files = [];
        var targetFolder = skipFolder ? path.resolve(target) : path.join(target, path.basename(source));
        if (!fs.existsSync(targetFolder)) {
            fs.mkdirSync(targetFolder);
        }
        if (fs.lstatSync(source).isDirectory()) {
            files = fs.readdirSync(source);
            files.forEach(function (file) {
                var curSource = path.join(source, file);
                if (fs.lstatSync(curSource).isDirectory()) {
                    _this.copyFolderRecursiveSync(curSource, targetFolder, false);
                }
                else {
                    _this.copyFileSync(curSource, targetFolder);
                }
            });
        }
    };
    return Copy;
}());
exports.default = Copy;
//# sourceMappingURL=copy.js.map