"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.compileEnvHashedString = exports.detectProdMode = void 0;
var detectProdMode = function () {
    var args = process.argv.slice(3);
    var prod = args.filter(function (arg) {
        return ['--ship', '--prod'].indexOf(arg.toLowerCase()) !== -1;
    }).length > 0;
    process.env.NODE_ENV = prod ? 'production' : 'development';
    return process.env.NODE_ENV;
};
exports.detectProdMode = detectProdMode;
var compileEnvHashedString = function (template) {
    var r = /{{(.*?)}}/g;
    var matches = [];
    var match = r.exec(template);
    while (match !== null) {
        var repl = match[1];
        var _a = repl.split(':'), envVar = _a[0], defaultValue = _a[1];
        var value = process.env[envVar] || defaultValue || '';
        matches.push([new RegExp("{{".concat(repl, "}}"), 'g'), value]);
        match = r.exec(template);
    }
    matches.forEach(function (_a) {
        var re = _a[0], v = _a[1];
        return template = template.replace(re, v);
    });
    return template;
};
exports.compileEnvHashedString = compileEnvHashedString;
//# sourceMappingURL=env.js.map