import { IDeploySettings } from '../interfaces';
export interface IFolderProcessItem {
    path: string;
    processed?: boolean;
}
export interface IFileProcessItem {
    path: string;
    relativePath?: string;
    length?: number;
    processed?: boolean;
}
export declare const extractSourcemapPath: (filePath: string) => string | null;
export default class Files {
    private settings;
    private sppurge;
    private spr;
    constructor(settings: IDeploySettings);
    getServerRelativeUrl: () => Promise<string>;
    getFiles: (foldersArr?: IFolderProcessItem[], filesArr?: IFileProcessItem[]) => Promise<IFileProcessItem[]>;
    deleteFile: (filePath: string) => Promise<void>;
    deleteFilesQueue: (filesQueue: {
        path: string;
        processed: boolean;
    }[]) => Promise<void>;
}
