"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractSourcemapPath = void 0;
var fs_1 = require("fs");
var sp_request_1 = require("sp-request");
var sppurge_1 = require("sppurge");
var colors = __importStar(require("colors"));
var extractSourcemapPath = function (filePath) {
    var innerRegex = /[#@] sourceMappingURL=([^\s'"]*)$/;
    var regex = RegExp('(?:' +
        '/\\*' +
        '(?:\\s*\r?\n(?://)?)?' +
        '(?:' + innerRegex.source + ')' +
        '\\s*' +
        '\\*/' +
        '|' +
        '//(?:' + innerRegex.source + ')' +
        ')' +
        '\\s*');
    var code = (0, fs_1.readFileSync)(filePath).toString();
    var match = code.match(regex);
    return (match ? match[1] || match[2] || '' : null);
};
exports.extractSourcemapPath = extractSourcemapPath;
var Files = (function () {
    function Files(settings) {
        var _this = this;
        this.getServerRelativeUrl = function () {
            var serverRelativeUrl = global.serverRelativeUrl;
            return new Promise(function (resolve) {
                if (typeof serverRelativeUrl !== 'undefined') {
                    resolve(serverRelativeUrl);
                }
                else {
                    var requestUrl = "".concat(_this.settings.siteUrl, "/_api/web?$select=ServerRelativeUrl");
                    _this.spr.get(requestUrl, {
                        headers: {
                            'Accept': 'application/json; odata=verbose',
                            'Content-Type': 'application/json; odata=verbose'
                        }
                    }).then(function (webProps) {
                        serverRelativeUrl = webProps.body.d.ServerRelativeUrl;
                        resolve(webProps.body.d.ServerRelativeUrl);
                    });
                }
            });
        };
        this.getFiles = function (foldersArr, filesArr) {
            if (foldersArr === void 0) { foldersArr = []; }
            if (filesArr === void 0) { filesArr = []; }
            return _this.getServerRelativeUrl().then(function (serverRelativeUrl) {
                if (foldersArr.length === 0) {
                    foldersArr.push({
                        path: "".concat(serverRelativeUrl, "/").concat(_this.settings.spFolder).replace(/\/\//g, '/'),
                        processed: false
                    });
                }
                if (foldersArr.filter(function (folder) { return !folder.processed; }).length === 0) {
                    return filesArr;
                }
                else {
                    var folder_1 = foldersArr.find(function (f) { return !f.processed; });
                    if (typeof folder_1 === 'undefined') {
                        return [];
                    }
                    var requestUrl = "".concat(_this.settings.siteUrl) +
                        "/_api/web/getFolderByServerRelativeUrl('".concat(folder_1.path, "')?") +
                        "$select=Files,Folders/ServerRelativeUrl,Folders/ItemCount&" +
                        "$expand=Files,Folders";
                    return _this.spr.get(requestUrl, {
                        headers: {
                            'Accept': 'application/json; odata=verbose',
                            'Content-Type': 'application/json; odata=verbose'
                        }
                    }).then(function (content) {
                        folder_1.processed = true;
                        filesArr = filesArr.concat(content.body.d.Files.results.map(function (fileResp) {
                            return {
                                path: fileResp.ServerRelativeUrl,
                                relativePath: fileResp.ServerRelativeUrl.replace("".concat(serverRelativeUrl, "/").concat(_this.settings.spFolder, "/").replace(/\/\//g, '/'), ''),
                                length: parseInt(fileResp.Length, 10)
                            };
                        }));
                        foldersArr = foldersArr.concat(content.body.d.Folders.results.map(function (folderResp) {
                            return {
                                path: folderResp.ServerRelativeUrl,
                                processed: folderResp.ItemCount === 0
                            };
                        }));
                        return _this.getFiles(foldersArr, filesArr);
                    });
                }
            });
        };
        this.deleteFile = function (filePath) {
            return _this.sppurge.deleteFile({
                siteUrl: _this.settings.siteUrl,
                creds: _this.settings.creds
            }, filePath);
        };
        this.deleteFilesQueue = function (filesQueue) { return __awaiter(_this, void 0, void 0, function () {
            var file;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(filesQueue.filter(function (file) { return !file.processed; }).length === 0)) return [3, 1];
                        return [2];
                    case 1:
                        file = filesQueue.find(function (folder) { return !folder.processed; });
                        if (typeof file === 'undefined') {
                            return [2];
                        }
                        console.log("Deleting ".concat(colors.red(file.path)));
                        return [4, this.deleteFile(file.path)];
                    case 2:
                        _a.sent();
                        file.processed = true;
                        return [4, this.deleteFilesQueue(filesQueue)];
                    case 3:
                        _a.sent();
                        return [2];
                }
            });
        }); };
        this.settings = __assign(__assign({}, settings), { dist: settings.dist || './dist' });
        this.sppurge = new sppurge_1.Delete();
        this.spr = (0, sp_request_1.create)(this.settings.creds);
    }
    return Files;
}());
exports.default = Files;
//# sourceMappingURL=files.js.map