"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Hashes = void 0;
var sp_commonjs_1 = require("@pnp/sp-commonjs");
var common_commonjs_1 = require("@pnp/common-commonjs");
var Hashes = (function () {
    function Hashes(props) {
        this.hashes = {
            '~publishroot/': { get: this.getPublishRootUrl.bind(this), needReplacement: true },
            '~site/': { get: this.getSiteUrl.bind(this), needReplacement: false },
            '~sitecollection/': { get: this.getSiteCollectionUrl.bind(this), needReplacement: false },
            '~hubsite/': { get: this.getHubSiteUrl.bind(this), needReplacement: true }
        };
        this.sp = props.sp;
        this.configs = props.configs;
        this.client = new sp_commonjs_1.SPHttpClient(new common_commonjs_1.Runtime());
    }
    Hashes.prototype.isHashedUrl = function (uri) {
        var str = uri.toLowerCase();
        return Object.keys(this.hashes)
            .filter(function (key) { return str.indexOf(key) !== -1; })
            .length > 0;
    };
    Hashes.prototype.replaceHashedUrl = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var str, rules, _i, rules_1, key, rule, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        str = uri.toLowerCase();
                        rules = Object.keys(this.hashes).filter(function (key) { return (str || '').indexOf(key) !== -1; });
                        _i = 0, rules_1 = rules;
                        _b.label = 1;
                    case 1:
                        if (!(_i < rules_1.length)) return [3, 5];
                        key = rules_1[_i];
                        rule = this.hashes[key];
                        if (!rule.needReplacement) return [3, 4];
                        if (!(typeof rule.value === 'undefined')) return [3, 3];
                        _a = rule;
                        return [4, rule.get().catch(function (error) {
                                console.log(error);
                                return undefined;
                            })];
                    case 2:
                        _a.value = _b.sent();
                        _b.label = 3;
                    case 3:
                        str = !rule.value ? null : (str || '').replace(new RegExp(key.replace(/\//g, ''), 'ig'), rule.value);
                        _b.label = 4;
                    case 4:
                        _i++;
                        return [3, 1];
                    case 5: return [2, str];
                }
            });
        });
    };
    Hashes.prototype.getHubSiteUrl = function () {
        return __awaiter(this, void 0, void 0, function () {
            var siteAbsoluteUrl, endpoint, siteHubData, hubRelativeUrl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.sp.site.select('Url').get()];
                    case 1:
                        siteAbsoluteUrl = (_a.sent()).Url;
                        endpoint = "".concat(siteAbsoluteUrl, "/_api/web/hubsitedata(false)");
                        return [4, this.client.get(endpoint)
                                .then(function (r) { return r.json(); })
                                .then(function (data) {
                                if (typeof data['odata.error'] !== 'undefined') {
                                    throw Error(data['odata.error'].message.value);
                                }
                                if (data.value === null) {
                                    return null;
                                }
                                return JSON.parse(data.value ? data.value : data.d.HubSiteData);
                            })];
                    case 2:
                        siteHubData = _a.sent();
                        if (siteHubData) {
                            hubRelativeUrl = '/' + siteHubData.url.split('/').splice(3).join('/').replace(/\/\//g, '/');
                            return [2, hubRelativeUrl];
                        }
                        else {
                            return [2, null];
                        }
                        return [2];
                }
            });
        });
    };
    Hashes.prototype.getSiteUrl = function () {
        return __awaiter(this, void 0, void 0, function () {
            var ServerRelativeUrl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.sp.web.select('ServerRelativeUrl').get()];
                    case 1:
                        ServerRelativeUrl = (_a.sent()).ServerRelativeUrl;
                        return [2, ServerRelativeUrl];
                }
            });
        });
    };
    Hashes.prototype.getSiteCollectionUrl = function () {
        return __awaiter(this, void 0, void 0, function () {
            var ServerRelativeUrl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.sp.site.select('ServerRelativeUrl').get()];
                    case 1:
                        ServerRelativeUrl = (_a.sent()).ServerRelativeUrl;
                        return [2, ServerRelativeUrl];
                }
            });
        });
    };
    Hashes.prototype.getPublishRootUrl = function () {
        return __awaiter(this, void 0, void 0, function () {
            var publishRootUrl;
            return __generator(this, function (_a) {
                publishRootUrl = '/' + (this.configs.privateConf.siteUrl + '/' + this.configs.appConfig.spFolder)
                    .split('/').splice(3).join('/').replace(/\/\//g, '/');
                return [2, publishRootUrl];
            });
        });
    };
    return Hashes;
}());
exports.Hashes = Hashes;
//# sourceMappingURL=hashes.js.map