"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseObjectChain = exports.Debounce = exports.execPromise = exports.formatTime = exports.walkFolders = void 0;
var fs = __importStar(require("fs"));
var child_process_1 = require("child_process");
var walkFolders = function (startFolder) {
    var results = [];
    var list = fs.readdirSync(startFolder);
    list.forEach(function (file) {
        var itemPath = "".concat(startFolder, "/").concat(file);
        var stat = fs.statSync(itemPath);
        if (stat && stat.isDirectory()) {
            results = results.concat((0, exports.walkFolders)(itemPath));
        }
        else {
            results.push(itemPath);
        }
    });
    return results;
};
exports.walkFolders = walkFolders;
var formatTime = function (date) {
    var hh = ('0' + date.getHours()).slice(-2);
    var mm = ('0' + date.getMinutes()).slice(-2);
    var ss = ('0' + date.getSeconds()).slice(-2);
    return "".concat(hh, ":").concat(mm, ":").concat(ss);
};
exports.formatTime = formatTime;
var execPromise = function (command) {
    return new Promise(function (resolve, reject) {
        (0, child_process_1.exec)(command, function (err, stdout, stderr) {
            if (err) {
                return reject(err);
            }
            resolve({ stdout: stdout, stderr: stderr });
        });
    });
};
exports.execPromise = execPromise;
var Debounce = (function () {
    function Debounce(delay) {
        if (delay === void 0) { delay = 100; }
        var _this = this;
        this.delay = delay;
        this.timers = {};
        this.run = function (key, cb) {
            clearTimeout(_this.timers[key]);
            _this.timers[key] = setTimeout(cb, _this.delay);
        };
    }
    return Debounce;
}());
exports.Debounce = Debounce;
var parseObjectChain = function (cb) {
    var result = null;
    try {
        result = cb();
    }
    catch (ex) { }
    return result;
};
exports.parseObjectChain = parseObjectChain;
//# sourceMappingURL=misc.js.map