"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = __importStar(require("path"));
var minimist_1 = __importDefault(require("minimist"));
var env_1 = require("../../utils/env");
var defaults_1 = require("../defaults");
var settings_1 = require("../settings");
var args = (0, minimist_1.default)(process.argv.slice(2));
var webpackTargets = (args['webpack-targets'] || '').split(',')
    .map(function (t) { return t.trim().toLowerCase(); })
    .filter(function (t) { return t.length > 0; });
var _a = (0, settings_1.getSettings)(), appConf = _a.appConf, privateConf = _a.privateConf, publishPath = _a.publishPath, defaultItemMap = _a.defaultItemMap;
var webpackItemsMap = appConf.webpackItemsMap || [defaultItemMap];
var webpackConfigDefaults = (0, defaults_1.getWebpackConfigDefaults)(appConf, privateConf, publishPath);
webpackConfigDefaults.name = '';
webpackConfigDefaults.entry = {};
webpackConfigDefaults.output = {
    path: path.join(process.cwd(), appConf.distFolder, (appConf.modulePath || ''), '/scripts'),
    filename: '[name].js',
    sourceMapFilename: "[name].js.map?v=[chunkhash:8]&e=.js.map",
    chunkFilename: '[name]/[id]-[chunkhash:8].js?v=[chunkhash:8]&e=.chunk.js',
    publicPath: "".concat(publishPath, "/scripts/")
};
var webpackConfigs = webpackItemsMap
    .filter(function (mapItem) {
    return webpackTargets.length !== 0
        ? true
        : mapItem.disable !== true;
})
    .filter(function (mapItem) {
    if (webpackTargets.length === 0) {
        return true;
    }
    return (webpackTargets.indexOf(mapItem.target.toLowerCase()) !== -1 ||
        webpackTargets.indexOf((mapItem.name || '').toLowerCase()) !== -1);
})
    .reduce(function (webpackCnfg, mapItem) {
    var _a;
    mapItem.target = mapItem.target.replace('.js', '');
    webpackCnfg[0].name += (webpackCnfg[0].name || '').length > 0
        ? ", ".concat(mapItem.name || mapItem.target)
        : "".concat(mapItem.name || mapItem.target);
    var output = [mapItem.entry];
    if (mapItem.includePolyfills === true) {
        output = __spreadArray([require.resolve('../polyfills')], output, true);
    }
    webpackCnfg[0].entry = __assign(__assign({}, (webpackCnfg[0].entry || {})), (_a = {}, _a[(0, env_1.compileEnvHashedString)(mapItem.target)] = output.map(env_1.compileEnvHashedString), _a));
    return webpackCnfg;
}, [webpackConfigDefaults]);
module.exports = webpackConfigs;
//# sourceMappingURL=v2.js.map