"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWebpackConfigDefaults = void 0;
var fork_ts_checker_webpack_plugin_1 = __importDefault(require("fork-ts-checker-webpack-plugin"));
var tsconfig_paths_webpack_plugin_1 = require("tsconfig-paths-webpack-plugin");
var rules_1 = require("../rules");
var devServer_1 = require("../devServer");
var getWebpackConfigDefaults = function (appConf, privateConf, publishPath) {
    var rules = (0, rules_1.getWebpackRules)();
    var devtool = (process.env.SPBUILD_WEBPACK_DEVTOOL || appConf.devtool);
    devtool = typeof devtool !== 'undefined' ? devtool : 'source-map';
    if ("".concat(devtool) === 'none' || "".concat(devtool) === '') {
        devtool = undefined;
    }
    return {
        mode: 'development',
        cache: true,
        devtool: devtool,
        devServer: (0, devServer_1.getDevServerOpts)(appConf, privateConf, publishPath),
        module: { rules: rules },
        resolve: {
            extensions: ['.ts', '.tsx', '.js', '.jsx'],
            plugins: [new tsconfig_paths_webpack_plugin_1.TsconfigPathsPlugin()]
        },
        plugins: [
            new fork_ts_checker_webpack_plugin_1.default({})
        ]
    };
};
exports.getWebpackConfigDefaults = getWebpackConfigDefaults;
//# sourceMappingURL=dev.js.map