"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWebpackRules = void 0;
var getWebpackRules = function () {
    var rules = [
        {
            test: /\.ts(x?)$/,
            exclude: /(node_modules|dist)/,
            use: [{
                    loader: 'ts-loader',
                    options: {
                        transpileOnly: true,
                        happyPackMode: true,
                        experimentalWatchApi: true
                    }
                }]
        },
        {
            test: /\.css$/,
            use: [
                { loader: 'style-loader' },
                {
                    loader: 'css-loader',
                    options: {
                        sourceMap: true,
                        url: false
                    }
                }
            ]
        },
        {
            test: /\.scss$/,
            use: [
                { loader: 'style-loader' },
                {
                    loader: 'css-loader',
                    options: {
                        sourceMap: true,
                        url: false
                    }
                },
                {
                    loader: 'sass-loader',
                    options: {
                        implementation: require('sass')
                    }
                }
            ]
        }
    ];
    return rules;
};
exports.getWebpackRules = getWebpackRules;
//# sourceMappingURL=rules.js.map