"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSettings = void 0;
var path = __importStar(require("path"));
var fs = __importStar(require("fs"));
var dotenv = __importStar(require("dotenv"));
dotenv.config();
var getSettings = function () {
    var configs = global.gulpConfigs;
    var appConf = (configs || { appConfig: null }).appConfig;
    var privateConf = (configs || { privateConf: null }).privateConf;
    if (!appConf) {
        appConf = require(path.join(process.cwd(), process.env.APP_JSON || './config/app.json'));
    }
    if (!privateConf) {
        privateConf = require(path.join(process.cwd(), process.env.PRIVATE_JSON || 'config/private.json'));
    }
    var publishPath = '/' + "".concat(privateConf.siteUrl, "/").concat(appConf.spFolder)
        .split('/').splice(3).join('/').replace(/\/\//g, '/');
    var defaultEntryExt = 'ts';
    var defEntryRoot = './src/scripts';
    ['js', 'jsx', 'ts', 'tsx'].forEach(function (ext) {
        if (fs.existsSync(path.join(process.cwd(), defEntryRoot, "index.".concat(ext)))) {
            defaultEntryExt = ext;
        }
    });
    var defaultItemMap = {
        entry: "".concat(defEntryRoot, "/index.").concat(defaultEntryExt),
        target: 'app.js'
    };
    return {
        appConf: appConf,
        privateConf: privateConf,
        publishPath: publishPath,
        defaultItemMap: defaultItemMap
    };
};
exports.getSettings = getSettings;
//# sourceMappingURL=settings.js.map